## About

ML.NET is a cross-platform open-source machine learning framework which makes machine learning accessible to .NET developers.

For more information, see the [ML.NET documentation](https://docs.microsoft.com/dotnet/machine-learning/).

This package adds the ability to load and run pre-trained ONNX models as part of your ML.NET pipeline.

## Key Features

* Any type of ONNX model can be run with all the data interop handled automatically.
* Image Featurization - Automatically featurize an image using a pre-trained DNN model.

## How to Use

See [Machine Learning Samples](https://github.com/dotnet/machinelearning-samples) for an assortment of samples that show how to get started using ML.NET.

## Main Types

Some of the types provided by this library are:

* `Microsoft.ML.Transforms.Onnx.OnnxOptions`
* `Microsoft.ML.Transforms.Onnx.OnnxScoringEstimator`
* `Microsoft.ML.Transforms.Onnx.OnnxTransformer`

## Additional Documentation

* [Conceptual documentation](https://learn.microsoft.com/en-us/dotnet/machine-learning/)
* [API documentation](https://learn.microsoft.com/en-us/dotnet/api/microsoft.ml.transforms.onnx)

## Related Packages

* Main Package: [Microsoft.ML](https://www.nuget.org/packages/Microsoft.ML)
* Core data abstraction: [Microsoft.ML.DataView](https://www.nuget.org/packages/Microsoft.ML.DataView)
* LightGBM Model Support: [Microsoft.ML.LightGbm](https://www.nuget.org/packages/Microsoft.ML.LightGbm)
* Fast Tree: [Microsoft.ML.FastTree](https://www.nuget.org/packages/Microsoft.ML.FastTree)
* Image analytics: [Microsoft.ML.ImageAnalytics](https://www.nuget.org/packages/Microsoft.ML.ImageAnalytics)
* Recommender: [Microsoft.ML.Recommender](https://www.nuget.org/packages/Microsoft.ML.Recommender)
* Time series: [Microsoft.ML.TimeSeries](https://www.nuget.org/packages/Microsoft.ML.TimeSeries)
* Automatic model selection / tuning:  [Microsoft.ML.AutoML](https://www.nuget.org/packages/Microsoft.ML.AutoML)
* Exporting Onnx Models: [Microsoft.ML.OnnxConverter](https://www.nuget.org/packages/Microsoft.ML.OnnxConverter)
* Text tokenizers: [Microsoft.ML.Tokenizers](https://www.nuget.org/packages/Microsoft.ML.Tokenizers)

## Feedback & Contributing

Microsoft.ML is released as open source under the [MIT license](https://licenses.nuget.org/MIT). Bug reports and contributions are welcome at [the GitHub repository](https://github.com/dotnet/machinelearning).